### R code from vignette source 'mhw_1c'

###################################################
### code chunk number 1: mhw_1c.Rnw:68-69
###################################################
head(row.names(mhw), n=10)


###################################################
### code chunk number 2: mhw_1c.Rnw:74-75
###################################################
head(mhw, n=10)


###################################################
### code chunk number 3: mhw_1c.Rnw:106-111
###################################################
dim(mhw)
(n <- dim(mhw)[1])
set.seed(123)
head(index.calib <- sort(sample(1:n, size=floor(n*3/4), replace=F)), n=12)
length(index.calib)


###################################################
### code chunk number 4: mhw_1c.Rnw:120-122
###################################################
head(index.valid <- setdiff(1:n, index.calib), n=12)
length(index.valid)


###################################################
### code chunk number 5: mhw_1c.Rnw:127-128
###################################################
setequal(union(index.calib, index.valid), 1:n)


###################################################
### code chunk number 6: mhw_1c.Rnw:140-142
###################################################
cal.straw.grain <- lm(straw ~ grain, data=mhw, subset=index.calib)
summary(cal.straw.grain)


###################################################
### code chunk number 7: mhw_1c.Rnw:151-155
###################################################
model.straw.grain <- lm(straw ~ grain, data=mhw)
(coef(cal.straw.grain) - coef(model.straw.grain))
((coef(cal.straw.grain) - coef(model.straw.grain))
                    /coef(model.straw.grain))*100


###################################################
### code chunk number 8: mhw_1c.Rnw:169-170
###################################################
pred <- predict.lm(cal.straw.grain, newdata=mhw[index.valid,])


###################################################
### code chunk number 9: mhw_1c.Rnw:181-182
###################################################
actual <- mhw[index.valid, "straw"]


###################################################
### code chunk number 10: mhw_1c.Rnw:188-195
###################################################
summary(pred); summary(actual)
par(mfrow=c(1,2))
hist(pred, main="", xlab="Predicted straw yields, lb / plot",
     breaks=seq(4,9.2,by=0.4), freq=F, ylim=c(0,.8))
hist(actual, main="", xlab="Actual straw yields, lb / plot",
     breaks=seq(4,9.2,by=0.4), freq=F, ylim=c(0,.8))
par(mfrow=c(1,1))


###################################################
### code chunk number 11: mhw_1c.Rnw:289-293
###################################################
plot(actual ~ pred, ylab="Actual", xlab="Predicted", asp=1,
     main="Mercer-Hall trial, straw yield, lbs/plot",
     xlim=c(4.5,9), ylim=c(4.5,9));
abline(0,1); grid()


###################################################
### code chunk number 12: mhw_1c.Rnw:306-309
###################################################
(valid.msd <- sum((actual - pred)^2)/length(index.valid))
(valid.msd <- mean((actual - pred)^2))
(valid.rmsep <- sqrt(valid.msd))


###################################################
### code chunk number 13: mhw_1c.Rnw:319-320
###################################################
(rmse <- sqrt(mean(residuals(cal.straw.grain)^2)))


###################################################
### code chunk number 14: mhw_1c.Rnw:329-332
###################################################
(valid.bias <- (mean(pred) - mean(actual)))
(valid.sb <- valid.bias^2)
valid.sb/valid.msd*100


###################################################
### code chunk number 15: mhw_1c.Rnw:352-362
###################################################
regr.actual.pred <- lm(actual ~ pred)
summary(regr.actual.pred)
plot(actual ~ pred, ylab="Actual", xlab="Predicted", asp=1,
     main="Mercer-Hall trial, straw yield, lbs/plot",
     xlim=c(4.5,9), ylim=c(4.5,9));
abline(regr.actual.pred, col="red")
abline(0,1); grid()
text(4.5, 8.5, paste("Gain:", round(coef(regr.actual.pred)[2], 2)),
     pos=4, col="red")
legend(7.5, 5, c("1:1","regression"), lty=1, col=c("black","red"))


###################################################
### code chunk number 16: mhw_1c.Rnw:372-382
###################################################
regr.actual.pred.0 <- lm(I(actual - pred) ~ pred)
summary(regr.actual.pred.0)
plot(I(actual - pred) ~ pred, ylab="Actual - Predicted",
     xlab="Predicted",
     main="Mercer-Hall trial, straw yield, lbs/plot")
grid(); abline(regr.actual.pred.0, col="red"); abline(h=0)
text(5, 1.6, paste("Slope:",
                   round(coef(regr.actual.pred.0)[2], 2)),
     pos=4, col="red")
legend(5, -1, c("1:1","regression"), lty=1, col=c("black","red"))


###################################################
### code chunk number 17: mhw_1c.Rnw:391-392
###################################################
coef(regr.actual.pred)[2] - coef(regr.actual.pred.0)[2]


###################################################
### code chunk number 18: mhw_1c.Rnw:405-406
###################################################
b <- coef(regr.actual.pred)[2]; names(b) <- NULL; print(b)


###################################################
### code chunk number 19: mhw_1c.Rnw:414-415
###################################################
(valid.msd.pred <- mean((pred - mean(pred))^2))


###################################################
### code chunk number 20: mhw_1c.Rnw:420-422
###################################################
(valid.nu <- (1 - b)^2 * valid.msd.pred)
valid.nu/valid.msd*100


###################################################
### code chunk number 21: mhw_1c.Rnw:439-440
###################################################
(valid.msd.actual <- mean((actual - mean(actual))^2))


###################################################
### code chunk number 22: mhw_1c.Rnw:445-449
###################################################
(r2 <- summary(regr.actual.pred)$r.squared)
(r2 <- cor(actual, pred)^2)
(valid.lc <- (1 - r2) * valid.msd.actual)
valid.lc/valid.msd * 100


###################################################
### code chunk number 23: mhw_1c.Rnw:458-459
###################################################
print(valid.msd - (valid.sb + valid.nu + valid.lc))


###################################################
### code chunk number 24: mhw_1c.Rnw:508-510
###################################################
cal.straw.grain.00 <- lm(straw ~ grain - 1, data=mhw, subset=index.calib)
summary(cal.straw.grain.00)


###################################################
### code chunk number 25: mhw_1c.Rnw:520-528
###################################################
plot(straw ~ grain, data=mhw, subset=index.calib, xlim=c(0,6), ylim=c(0,9))
title("Mercer-Hall trial, calibration dataset")
abline(cal.straw.grain, lty=2)
abline(cal.straw.grain.00, col="red")
grid()
legend(4, 1, c("with intercept","no intercept"), lty=c(2,1), col=c("black","red"))
text(0, 2.5, paste("Slope:",round(coef(cal.straw.grain)[2],2)), pos=4)
text(1, 0.5, paste("Slope:",round(coef(cal.straw.grain.00)[1],2)), col="red")


###################################################
### code chunk number 26: mhw_1c.Rnw:540-542
###################################################
pred <- predict.lm(cal.straw.grain.00, newdata=mhw[index.valid,])
summary(pred)


###################################################
### code chunk number 27: mhw_1c.Rnw:550-561
###################################################
regr.actual.pred.00 <- lm(actual ~ pred)
plot(actual ~ pred, ylab="Actual", xlab="Predicted", asp=1,
     main="Mercer-Hall trial, straw yield, lbs/plot",
     xlim=c(4.5,9), ylim=c(4.5,9));
abline(regr.actual.pred.00, col="red")
abline(0,1); grid()
text(4.5, 8.5, paste("Gain:",
                     round(coef(regr.actual.pred.00)[2], 2)),
     pos=4, col="red")
legend(7.5, 5, c("1:1","regression"), lty=1,
       col=c("black","red"))


###################################################
### code chunk number 28: mhw_1c.Rnw:568-573
###################################################
(msd.00 <- mean((actual - pred)^2))
(rmsep.00 <- sqrt(msd.00))
(sb.00 <- (mean(pred) - mean(actual))^2)
(nu.00 <- (1 - coef(regr.actual.pred.00)[2])^2 * mean((pred - mean(pred))^2))
(lc.00 <- (1 - cor(actual, pred)^2) * mean((actual - mean(actual))^2))


###################################################
### code chunk number 29: mhw_1c.Rnw:580-584
###################################################
sb.00/msd.00*100
nu.00/msd.00*100
lc.00/msd.00*100
msd.00 - (sb.00 + nu.00 + lc.00)


###################################################
### code chunk number 30: mhw_1c.Rnw:677-682
###################################################
rm(n, index.valid, index.calib, actual)
rm(cal.straw.grain, pred)
rm(valid.msd, rmse)
rm(regr.actual.pred, regr.actual.pred.0, valid.bias, valid.sb, valid.lc, b, valid.nu, valid.msd.pred, valid.msd.actual, r2)
rm(cal.straw.grain.00, regr.actual.pred.00, msd.00, rmsep.00, sb.00, nu.00, lc.00)


